#!/usr/bin/env python
# -*- encoding: utf-8 -*-


from ui.own.frame_theme import MyFrame
from ui.main.top_page import TopPage
from ui.main.center_page import CenterPage
from ui.main.under_page import UnderPage
from utils.qt import  QMetaObject, QVBoxLayout


class Main(MyFrame):
    def setupUi(self, Main):
        self.main = MyFrame(Main)
        self.main_layout = QVBoxLayout(self.main)
        self.main_layout.setContentsMargins(0, 0, 0, 0)
        self.main_layout.setSpacing(0)

        self.top_widget = TopPage(self.main)
        self.main_layout.addWidget(self.top_widget)

        self.center_widget = CenterPage(self.main)
        self.main_layout.addWidget(self.center_widget)

        self.under_widget = UnderPage(self.main)
        self.main_layout.addWidget(self.under_widget)

        QMetaObject.connectSlotsByName(Main)
